> For the complete documentation index, see [llms.txt](https://docs.apryse.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.apryse.com/web/get-started/faq/save-load-custom-props.md).

# How to save and load a custom property on an annotation?

World's #1 PDF SDK Library for Web, Mobile, Server, Desktop

The recommended way is to use the [`setCustomData`](https://sdk.apryse.com/api/web/Core.Annotations.Annotation.html#setCustomData) function on annotations.

{% tabs %}
{% tab title="JavaScript" %}
{% code lineNumbers="true" %}

```js
const myCustomAttributeValue = 'some custom data';
myAnnotation.setCustomData('myCustomAttribute', myCustomAttributeValue);
```

{% endcode %}
{% endtab %}
{% endtabs %}

When the PDF is downloaded this data will also be embedded inside the PDF and if you re-open the PDF in WebViewer it will be accessible through the [`getCustomData`](https://sdk.apryse.com/api/web/Core.Annotations.Annotation.html#getCustomData) function.

{% tabs %}
{% tab title="JavaScript" %}
{% code lineNumbers="true" %}

```js
const myCustomAttributeValue = myAnnotation.getCustomData('myCustomAttribute');
```

{% endcode %}
{% endtab %}
{% endtabs %}

Alternatively you can use the [`setCustomSerializeHandler`](https://sdk.apryse.com/api/web/Core.Annotations.html#.setCustomSerializeHandler) and [`setCustomDeserializeHandler`](https://sdk.apryse.com/api/web/Core.Annotations.html#.setCustomDeserializeHandler) APIs, however note that saving an attribute this way will only work if you load XFDF separately from the PDF. If you download the PDF the attribute will not be preserved.

{% tabs %}
{% tab title="JavaScript" %}
{% code lineNumbers="true" %}

```js
const { Annotations } = instance.Core.Annotations;

Annotations.setCustomSerializeHandler(Annotations.Annotation, function(element, pageMatrix, options) {
  options.originalSerialize(element, pageMatrix);
  if (options.annotation.myCustomAttribute) {
    element.setAttribute('attribute-name', options.annotation.myCustomAttribute);
  }
  return element;
});

Annotations.setCustomDeserializeHandler(Annotations.Annotation, function(element, pageMatrix, options) {
  options.originalDeserialize(element, pageMatrix);
  options.annotation.myCustomAttribute = element.getAttribute('attribute-name');
});
```

{% endcode %}
{% endtab %}
{% endtabs %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.apryse.com/web/get-started/faq/save-load-custom-props.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
